Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/provisioning_client/src/prov_device_client.c
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/provisioning_client/src/prov_device_client.c	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/provisioning_client/src/prov_device_client.c	(revision 464)
@@ -15,6 +15,4 @@
 
 #define DO_WORK_FREQ_DEFAULT 1
-
-static const char* const OPTION_DO_WORK_FREQUENCY_IN_MS = "do_work_freq_ms";
 
 typedef struct PROV_DEVICE_INSTANCE_TAG
@@ -260,5 +258,5 @@
         {
             /* Codes_SRS_PROV_DEVICE_CLIENT_41_001: [ If parameter `optionName` is `OPTION_DO_WORK_FREQUENCY_IN_MS` then `IoTHubClientCore_SetOption` shall set `do_work_freq_ms` parameter of `prov_device_instance` ] */
-            if (strcmp(OPTION_DO_WORK_FREQUENCY_IN_MS, optionName) == 0)
+            if (strcmp(PROV_OPTION_DO_WORK_FREQUENCY_IN_MS, optionName) == 0)
             {
                 prov_device_instance->do_work_freq_ms = *((uint16_t *)value);
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/provisioning_client/src/prov_device_ll_client.c
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/provisioning_client/src/prov_device_ll_client.c	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/provisioning_client/src/prov_device_ll_client.c	(revision 464)
@@ -93,7 +93,7 @@
     TICK_COUNTER_HANDLE tick_counter;
 
-    tickcounter_ms_t status_throttle;
+    tickcounter_ms_t last_send_time_ms;
     tickcounter_ms_t timeout_value;
-    uint32_t retry_after_value;
+    size_t retry_after_ms;
 
     uint8_t prov_timeout;
@@ -784,5 +784,5 @@
         PROV_INSTANCE_INFO* prov_info = (PROV_INSTANCE_INFO*)user_ctx;
 
-        prov_info->retry_after_value = retry_interval;
+        prov_info->retry_after_ms = (size_t)retry_interval * 1000; // retry_interval is in seconds.
 
         switch (transport_status)
@@ -880,5 +880,5 @@
             /* Codes_SRS_PROV_CLIENT_07_028: [ CLIENT_STATE_READY is the initial state after the object is created which will send a uhttp_client_open call to the http endpoint. ] */
             result->prov_state = CLIENT_STATE_READY;
-            result->retry_after_value = PROV_GET_THROTTLE_TIME;
+            result->retry_after_ms = PROV_GET_THROTTLE_TIME * 1000;
             result->prov_transport_protocol = protocol();
             result->error_reason = PROV_DEVICE_RESULT_OK;
@@ -931,6 +931,6 @@
                 {
                     // Ensure that we are passed the throttling time and send on the first send
-                    (void)tickcounter_get_current_ms(result->tick_counter, &result->status_throttle);
-                    result->status_throttle += (result->retry_after_value * 1000);
+                    (void)tickcounter_get_current_ms(result->tick_counter, &result->last_send_time_ms);
+                    result->last_send_time_ms += result->retry_after_ms;
                 }
             }
@@ -1119,27 +1119,9 @@
         if (prov_info->is_connected || prov_info->prov_state == CLIENT_STATE_ERROR)
         {
+            tickcounter_ms_t current_time = 0;
+
             switch (prov_info->prov_state)
             {
                 case CLIENT_STATE_REGISTER_SEND:
-                    /* Codes_SRS_PROV_CLIENT_07_013: [ CLIENT_STATE_REGISTER_SEND which shall construct an initial call to the service with endorsement information ] */
-                    if (prov_info->prov_transport_protocol->prov_transport_register(prov_info->transport_handle, prov_transport_process_json_reply, prov_transport_create_json_payload, prov_info) != 0)
-                    {
-                        LogError("Failure registering device");
-                        if (prov_info->error_reason == PROV_DEVICE_RESULT_OK)
-                        {
-                            prov_info->error_reason = PROV_DEVICE_RESULT_TRANSPORT;
-                        }
-                        prov_info->prov_state = CLIENT_STATE_ERROR;
-                    }
-                    else
-                    {
-                        (void)tickcounter_get_current_ms(prov_info->tick_counter, &prov_info->timeout_value);
-                        prov_info->prov_state = CLIENT_STATE_REGISTER_SENT;
-                    }
-                    break;
-
-                case CLIENT_STATE_STATUS_SEND:
-                {
-                    tickcounter_ms_t current_time = 0;
                     if (tickcounter_get_current_ms(prov_info->tick_counter, &current_time) != 0)
                     {
@@ -1150,5 +1132,37 @@
                     else
                     {
-                        if ((current_time - prov_info->status_throttle) / 1000 > prov_info->retry_after_value)
+                        if ((current_time - prov_info->last_send_time_ms) > prov_info->retry_after_ms)
+                        {
+                            /* Codes_SRS_PROV_CLIENT_07_013: [ CLIENT_STATE_REGISTER_SEND which shall construct an initial call to the service with endorsement information ] */
+                            if (prov_info->prov_transport_protocol->prov_transport_register(prov_info->transport_handle, prov_transport_process_json_reply, prov_transport_create_json_payload, prov_info) != 0)
+                            {
+                                LogError("Failure registering device");
+                                if (prov_info->error_reason == PROV_DEVICE_RESULT_OK)
+                                {
+                                    prov_info->error_reason = PROV_DEVICE_RESULT_TRANSPORT;
+                                }
+                                prov_info->prov_state = CLIENT_STATE_ERROR;
+                            }
+                            else
+                            {
+                                (void)tickcounter_get_current_ms(prov_info->tick_counter, &prov_info->timeout_value);
+                                prov_info->prov_state = CLIENT_STATE_REGISTER_SENT;
+                            }
+                            prov_info->last_send_time_ms = current_time;
+                        }
+                    }
+                    break;
+
+                case CLIENT_STATE_STATUS_SEND:
+                {
+                    if (tickcounter_get_current_ms(prov_info->tick_counter, &current_time) != 0)
+                    {
+                        LogError("Failure getting the current time");
+                        prov_info->error_reason = PROV_DEVICE_RESULT_ERROR;
+                        prov_info->prov_state = CLIENT_STATE_ERROR;
+                    }
+                    else
+                    {
+                        if ((current_time - prov_info->last_send_time_ms) > prov_info->retry_after_ms)
                         {
                             /* Codes_SRS_PROV_CLIENT_07_026: [ Upon receiving the reply of the CLIENT_STATE_URL_REQ_SEND message from  iothub_client shall process the the reply of the CLIENT_STATE_URL_REQ_SEND state ] */
@@ -1172,5 +1186,5 @@
                                 }
                             }
-                            prov_info->status_throttle = current_time;
+                            prov_info->last_send_time_ms = current_time;
                         }
                     }
@@ -1183,5 +1197,4 @@
                     if (prov_info->prov_timeout > 0)
                     {
-                        tickcounter_ms_t current_time = 0;
                         (void)tickcounter_get_current_ms(prov_info->tick_counter, &current_time);
                         if ((current_time - prov_info->timeout_value) / 1000 > prov_info->prov_timeout)
@@ -1279,5 +1292,5 @@
             if (value == NULL)
             {
-                LogError("setting proxy options");
+                LogError("setting PROV_OPTION_TIMEOUT option");
                 result = PROV_DEVICE_RESULT_ERROR;
             }
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/provisioning_client/src/prov_transport_mqtt_common.c
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/provisioning_client/src/prov_transport_mqtt_common.c	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/provisioning_client/src/prov_transport_mqtt_common.c	(revision 464)
@@ -320,5 +320,5 @@
             if (memcmp(MQTT_TOPIC_STATUS_PREFIX, topic_resp, status_pos) == 0)
             {
-                // If the status code is > 429 then this is a transient error
+                // If the status code is >= 429 then this is a transient error
                 long status_code = atol(topic_resp + status_pos);
                 if (status_code >= PROV_STATUS_CODE_TRANSIENT_ERROR)
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/inc/azure_umqtt_c/mqtt_client.h
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/inc/azure_umqtt_c/mqtt_client.h	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/inc/azure_umqtt_c/mqtt_client.h	(revision 464)
@@ -49,4 +49,5 @@
 typedef void(*ON_MQTT_DISCONNECTED_CALLBACK)(void* callbackCtx);
 
+MOCKABLE_FUNCTION(, void, mqtt_client_clear_xio, MQTT_CLIENT_HANDLE, handle);
 MOCKABLE_FUNCTION(, MQTT_CLIENT_HANDLE, mqtt_client_init, ON_MQTT_MESSAGE_RECV_CALLBACK, msgRecv, ON_MQTT_OPERATION_CALLBACK, opCallback, void*, opCallbackCtx, ON_MQTT_ERROR_CALLBACK, onErrorCallBack, void*, errorCBCtx);
 MOCKABLE_FUNCTION(, void, mqtt_client_deinit, MQTT_CLIENT_HANDLE, handle);
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/inc/azure_umqtt_c/mqttconst.h
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/inc/azure_umqtt_c/mqttconst.h	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/inc/azure_umqtt_c/mqttconst.h	(revision 464)
@@ -33,5 +33,7 @@
     DISCONNECT_TYPE, 0xE0, \
     PACKET_TYPE_ERROR, 0xE1, /* 0xE1 was assigned because ENUM_2 needs it */ \
-    UNKNOWN_TYPE, 0xE2 /* 0xE2 was assigned because ENUM_2 needs it */
+    UNKNOWN_TYPE, 0xE2,      /* 0xE2 was assigned because ENUM_2 needs it */ \
+    PACKET_INVALID1_TYPE, 0x00, \
+    PACKET_INVALID2_TYPE, 0xF0
 
 MU_DEFINE_ENUM_2(CONTROL_PACKET_TYPE, CONTROL_PACKET_TYPE_VALUES)
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/src/mqtt_client.c
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/src/mqtt_client.c	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/src/mqtt_client.c	(revision 464)
@@ -770,5 +770,20 @@
                     /*Codes_SRS_MQTT_CLIENT_07_028: [If the actionResult parameter is of type CONNECT_ACK then the msgInfo value shall be a CONNECT_ACK structure.]*/
                     CONNECT_ACK connack = { 0 };
-                    connack.isSessionPresent = (byteutil_readByte(&iterator) == 0x1) ? true : false;
+                    if (packetLength != 2) // CONNACK payload must be only 2 bytes
+                    {
+                        LogError("Invalid CONNACK packet.");
+                        set_error_callback(mqtt_client, MQTT_CLIENT_COMMUNICATION_ERROR);
+                        break;
+                    }
+
+                    uint8_t connect_acknowledge_flags = byteutil_readByte(&iterator);
+                    if (connect_acknowledge_flags & 0xFE) // bits 7-1 must be zero
+                    {
+                        LogError("Invalid CONNACK packet.");
+                        set_error_callback(mqtt_client, MQTT_CLIENT_COMMUNICATION_ERROR);
+                        break;
+                    }
+
+                    connack.isSessionPresent = (connect_acknowledge_flags == 0x1) ? true : false;
                     uint8_t rc = byteutil_readByte(&iterator);
                     connack.returnCode =
@@ -802,4 +817,11 @@
                 case PUBCOMP_TYPE:
                 {
+                    if (packetLength != 2) // PUBXXX payload must be only 2 bytes
+                    {
+                        LogError("Invalid packet length.");
+                        set_error_callback(mqtt_client, MQTT_CLIENT_COMMUNICATION_ERROR);
+                        break;
+                    }
+
                     /*Codes_SRS_MQTT_CLIENT_07_029: [If the actionResult parameter are of types PUBACK_TYPE, PUBREC_TYPE, PUBREL_TYPE or PUBCOMP_TYPE then the msgInfo value shall be a PUBLISH_ACK structure.]*/
                     MQTT_CLIENT_EVENT_RESULT action = (packet == PUBACK_TYPE) ? MQTT_CLIENT_ON_PUBLISH_ACK :
@@ -876,4 +898,10 @@
                         {
                             uint8_t qosRet = byteutil_readByte(&iterator);
+                            if (qosRet & 0x7C) // SUBACK QOS bits 6-2 must be zero
+                            {
+                                LogError("Invalid SUBACK_TYPE packet.");
+                                set_error_callback(mqtt_client, MQTT_CLIENT_COMMUNICATION_ERROR);
+                                break;
+                            }
                             suback.qosReturn[suback.qosCount++] =
                                 (qosRet <= ((uint8_t)DELIVER_EXACTLY_ONCE)) ?
@@ -909,4 +937,11 @@
                     /*Codes_SRS_MQTT_CLIENT_07_031: [If the actionResult parameter is of type UNSUBACK_TYPE then the msgInfo value shall be a UNSUBSCRIBE_ACK structure.]*/
                     UNSUBSCRIBE_ACK unsuback = { 0 };
+                    if (packetLength != 2) // UNSUBACK_TYPE payload must be only 2 bytes
+                    {
+                        LogError("Invalid UNSUBACK packet length.");
+                        set_error_callback(mqtt_client, MQTT_CLIENT_COMMUNICATION_ERROR);
+                        break;
+                    }
+
                     unsuback.packetId = byteutil_read_uint16(&iterator, packetLength);
 
@@ -943,4 +978,20 @@
     {
         LogError("recvCompleteCallback context failed.");
+    }
+}
+
+void mqtt_client_clear_xio(MQTT_CLIENT_HANDLE handle)
+{
+    if (handle != NULL)
+    {
+        MQTT_CLIENT *mqtt_client = (MQTT_CLIENT *)handle;
+
+        // The upstream transport handle allocates and deallocates the xio handle.
+        // The reference to that xio handle is shared between this layer (mqtt layer)
+        // and the upstream layer. The clearing done here is to signal to this layer
+        // that the handle is no longer available to be used. This is different from
+        // deiniting the mqtt client in that we do not want an entire teardown, but
+        // only a possible re-upping of the xio in the future.
+        mqtt_client->xioHandle = NULL;
     }
 }
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/src/mqtt_codec.c
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/src/mqtt_codec.c	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/umqtt/src/mqtt_codec.c	(revision 464)
@@ -568,4 +568,14 @@
             }
         }
+    }
+    else if (codecData->remainLenIndex == (sizeof(codecData->storeRemainLen) / sizeof(codecData->storeRemainLen[0])))
+    {
+        // The maximum number of bytes in the Remaining Length field is four
+        // This allows applications to send Control Packets of size up to 268,435,455 (256 MB). 
+        // The representation of this number on the wire is: 0xFF, 0xFF, 0xFF, 0x7F.
+
+        // The last byte has exceed the max value of 0x7F
+        LogError("MQTT packet len is invalid");
+        result = MU_FAILURE;
     }
     return result;
@@ -1067,4 +1077,47 @@
                 {
                     codec_Data->currPacket = processControlPacketType(iterator, &codec_Data->headerFlags);
+
+                    // validate packet type and invalid reserved header flags
+                    switch (codec_Data->currPacket)
+                    {
+                        case PACKET_INVALID1_TYPE:
+                        case PACKET_INVALID2_TYPE:
+                            codec_Data->currPacket = PACKET_TYPE_ERROR;
+                            result = MU_FAILURE;
+                            break;
+
+                        case CONNECT_TYPE:
+                        case CONNACK_TYPE:
+                        case PUBACK_TYPE:
+                        case PUBREC_TYPE:
+                        case PUBCOMP_TYPE:
+                        case SUBACK_TYPE:
+                        case UNSUBACK_TYPE:
+                        case PINGREQ_TYPE:
+                        case PINGRESP_TYPE:
+                        case DISCONNECT_TYPE:
+                            if (codec_Data->headerFlags & 0x0F) // flags must be all zeros
+                            {
+                                codec_Data->currPacket = PACKET_TYPE_ERROR;
+                                result = MU_FAILURE;
+                            }
+                            break;
+
+                        case PUBREL_TYPE:
+                        case SUBSCRIBE_TYPE:
+                        case UNSUBSCRIBE_TYPE:
+                            if ((codec_Data->headerFlags & 0x0F) != 0x02) // only bit 1 must be set
+                            {
+                                codec_Data->currPacket = PACKET_TYPE_ERROR;
+                                result = MU_FAILURE;
+                            }
+                            break;
+
+                        case PUBLISH_TYPE:
+                        case CONTROL_PACKET_TYPE_INVALID: 
+                        case PACKET_TYPE_ERROR:
+                        case UNKNOWN_TYPE:
+                            break;
+                    }
                 }
                 else
@@ -1078,6 +1131,15 @@
                     else if (codec_Data->currPacket == PINGRESP_TYPE)
                     {
-                        /* Codes_SRS_MQTT_CODEC_07_034: [Upon a constructing a complete MQTT packet mqtt_codec_bytesReceived shall call the ON_PACKET_COMPLETE_CALLBACK function.] */
-                        completePacketData(codec_Data);
+                        // PINGRESP must not have a payload
+                        if (((int8_t*)buffer)[index] == 0)
+                        {
+                            /* Codes_SRS_MQTT_CODEC_07_034: [Upon a constructing a complete MQTT packet mqtt_codec_bytesReceived shall call the ON_PACKET_COMPLETE_CALLBACK function.] */
+                            completePacketData(codec_Data);
+                        }
+                        else
+                        {
+                            codec_Data->currPacket = PACKET_TYPE_ERROR;
+                            result = MU_FAILURE;
+                        }
                     }
                 }
